/**
 * FilterSet.java
 *
 * File generated from the core::FilterSet uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class FilterSet.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "FilterSet", propOrder = {
	"group"
})
@XmlRootElement(name = "FilterSet")
public class FilterSet implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "and", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "or", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "not", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "equalityMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "substrings", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "greaterOrEqual", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "lessOrEqual", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "present", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "approxMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "extensibleMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class)
		})
	public List<java.io.Serializable> group;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return group.
	 * @return group
	 */
	public List<java.io.Serializable> getGroup() {
		if (group == null) {
	        group = new ArrayList<java.io.Serializable>();
	    }
	    return group;
	}
	
	/**
	 * Set a value to attribute group.
	 * @param group.
	 */
	public void setGroup(List<java.io.Serializable> group) {
	    this.group = group;
	}
	
	
	
	/**
	 * Add a group to the group collection.
	 * @param group_elt Element to add.
	 */
	public void addGroup(java.io.Serializable group_elt) {
	    this.getGroup().add(group_elt);
	}
	
	/**
	 * Remove a group to the group collection.
	 * @param group_elt Element to remove
	 */
	public void removeGroup(java.io.Serializable group_elt) {
	    this.getGroup().remove(group_elt);
	}
	
	/**
	 * Return and.
	 * @return and
	 */
	public List<net.ihe.gazelle.hpd.FilterSet> getAnd() {
		List<net.ihe.gazelle.hpd.FilterSet> and_el = new ArrayList<net.ihe.gazelle.hpd.FilterSet>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("and")){
					and_el.add( (net.ihe.gazelle.hpd.FilterSet) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return and_el;
	}
	
	public void addAnd(net.ihe.gazelle.hpd.FilterSet obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.FilterSet> jobj = of.createFilterSetAnd(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return or.
	 * @return or
	 */
	public List<net.ihe.gazelle.hpd.FilterSet> getOr() {
		List<net.ihe.gazelle.hpd.FilterSet> or_el = new ArrayList<net.ihe.gazelle.hpd.FilterSet>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("or")){
					or_el.add( (net.ihe.gazelle.hpd.FilterSet) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return or_el;
	}
	
	public void addOr(net.ihe.gazelle.hpd.FilterSet obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.FilterSet> jobj = of.createFilterSetOr(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return not.
	 * @return not
	 */
	public List<net.ihe.gazelle.hpd.Filter> getNot() {
		List<net.ihe.gazelle.hpd.Filter> not_el = new ArrayList<net.ihe.gazelle.hpd.Filter>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("not")){
					not_el.add( (net.ihe.gazelle.hpd.Filter) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return not_el;
	}
	
	public void addNot(net.ihe.gazelle.hpd.Filter obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.Filter> jobj = of.createFilterSetNot(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return equalityMatch.
	 * @return equalityMatch
	 */
	public List<net.ihe.gazelle.hpd.AttributeValueAssertion> getEqualityMatch() {
		List<net.ihe.gazelle.hpd.AttributeValueAssertion> equalityMatch_el = new ArrayList<net.ihe.gazelle.hpd.AttributeValueAssertion>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("equalityMatch")){
					equalityMatch_el.add( (net.ihe.gazelle.hpd.AttributeValueAssertion) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return equalityMatch_el;
	}
	
	public void addEqualityMatch(net.ihe.gazelle.hpd.AttributeValueAssertion obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeValueAssertion> jobj = of.createFilterSetEqualityMatch(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return substrings.
	 * @return substrings
	 */
	public List<net.ihe.gazelle.hpd.SubstringFilter> getSubstrings() {
		List<net.ihe.gazelle.hpd.SubstringFilter> substrings_el = new ArrayList<net.ihe.gazelle.hpd.SubstringFilter>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("substrings")){
					substrings_el.add( (net.ihe.gazelle.hpd.SubstringFilter) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return substrings_el;
	}
	
	public void addSubstrings(net.ihe.gazelle.hpd.SubstringFilter obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.SubstringFilter> jobj = of.createFilterSetSubstrings(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return greaterOrEqual.
	 * @return greaterOrEqual
	 */
	public List<net.ihe.gazelle.hpd.AttributeValueAssertion> getGreaterOrEqual() {
		List<net.ihe.gazelle.hpd.AttributeValueAssertion> greaterOrEqual_el = new ArrayList<net.ihe.gazelle.hpd.AttributeValueAssertion>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("greaterOrEqual")){
					greaterOrEqual_el.add( (net.ihe.gazelle.hpd.AttributeValueAssertion) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return greaterOrEqual_el;
	}
	
	public void addGreaterOrEqual(net.ihe.gazelle.hpd.AttributeValueAssertion obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeValueAssertion> jobj = of.createFilterSetGreaterOrEqual(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return lessOrEqual.
	 * @return lessOrEqual
	 */
	public List<net.ihe.gazelle.hpd.AttributeValueAssertion> getLessOrEqual() {
		List<net.ihe.gazelle.hpd.AttributeValueAssertion> lessOrEqual_el = new ArrayList<net.ihe.gazelle.hpd.AttributeValueAssertion>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("lessOrEqual")){
					lessOrEqual_el.add( (net.ihe.gazelle.hpd.AttributeValueAssertion) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return lessOrEqual_el;
	}
	
	public void addLessOrEqual(net.ihe.gazelle.hpd.AttributeValueAssertion obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeValueAssertion> jobj = of.createFilterSetLessOrEqual(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return present.
	 * @return present
	 */
	public List<net.ihe.gazelle.hpd.AttributeDescription> getPresent() {
		List<net.ihe.gazelle.hpd.AttributeDescription> present_el = new ArrayList<net.ihe.gazelle.hpd.AttributeDescription>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("present")){
					present_el.add( (net.ihe.gazelle.hpd.AttributeDescription) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return present_el;
	}
	
	public void addPresent(net.ihe.gazelle.hpd.AttributeDescription obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeDescription> jobj = of.createFilterSetPresent(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return approxMatch.
	 * @return approxMatch
	 */
	public List<net.ihe.gazelle.hpd.AttributeValueAssertion> getApproxMatch() {
		List<net.ihe.gazelle.hpd.AttributeValueAssertion> approxMatch_el = new ArrayList<net.ihe.gazelle.hpd.AttributeValueAssertion>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("approxMatch")){
					approxMatch_el.add( (net.ihe.gazelle.hpd.AttributeValueAssertion) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return approxMatch_el;
	}
	
	public void addApproxMatch(net.ihe.gazelle.hpd.AttributeValueAssertion obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeValueAssertion> jobj = of.createFilterSetApproxMatch(obj);
		this.getGroup().add(jobj);
	}
	
	/**
	 * Return extensibleMatch.
	 * @return extensibleMatch
	 */
	public List<net.ihe.gazelle.hpd.MatchingRuleAssertion> getExtensibleMatch() {
		List<net.ihe.gazelle.hpd.MatchingRuleAssertion> extensibleMatch_el = new ArrayList<net.ihe.gazelle.hpd.MatchingRuleAssertion>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("extensibleMatch")){
					extensibleMatch_el.add( (net.ihe.gazelle.hpd.MatchingRuleAssertion) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return extensibleMatch_el;
	}
	
	public void addExtensibleMatch(net.ihe.gazelle.hpd.MatchingRuleAssertion obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.MatchingRuleAssertion> jobj = of.createFilterSetExtensibleMatch(obj);
		this.getGroup().add(jobj);
	}
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "FilterSet").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(FilterSet filterSet, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (filterSet != null){
   			cvm.validate(filterSet, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.FilterSet and: filterSet.getAnd()){
					net.ihe.gazelle.hpd.FilterSet.validateByModule(and, _location + "/and[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.FilterSet or: filterSet.getOr()){
					net.ihe.gazelle.hpd.FilterSet.validateByModule(or, _location + "/or[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.Filter not: filterSet.getNot()){
					net.ihe.gazelle.hpd.Filter.validateByModule(not, _location + "/not[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeValueAssertion equalityMatch: filterSet.getEqualityMatch()){
					net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(equalityMatch, _location + "/equalityMatch[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.SubstringFilter substrings: filterSet.getSubstrings()){
					net.ihe.gazelle.hpd.SubstringFilter.validateByModule(substrings, _location + "/substrings[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeValueAssertion greaterOrEqual: filterSet.getGreaterOrEqual()){
					net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(greaterOrEqual, _location + "/greaterOrEqual[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeValueAssertion lessOrEqual: filterSet.getLessOrEqual()){
					net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(lessOrEqual, _location + "/lessOrEqual[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeDescription present: filterSet.getPresent()){
					net.ihe.gazelle.hpd.AttributeDescription.validateByModule(present, _location + "/present[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeValueAssertion approxMatch: filterSet.getApproxMatch()){
					net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(approxMatch, _location + "/approxMatch[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.MatchingRuleAssertion extensibleMatch: filterSet.getExtensibleMatch()){
					net.ihe.gazelle.hpd.MatchingRuleAssertion.validateByModule(extensibleMatch, _location + "/extensibleMatch[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}